"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const html_webpack_plugin_1 = tslib_1.__importDefault(require("html-webpack-plugin"));
class HTMLAttributePlugin {
    constructor(options = { script: {}, style: {} }) {
        this.options = options;
    }
    apply(compiler) {
        const options = this.options;
        if (typeof options !== 'object' || options == null) {
            return;
        }
        compiler.hooks.compilation.tap('HTMLAttributePlugin', (compilation) => {
            // @ts-ignore
            html_webpack_plugin_1.default.getHooks(compilation).alterAssetTags.tapAsync('HTMLAttributePlugin', (data, callback) => {
                data.assetTags.scripts = data.assetTags.scripts.map((script) => {
                    return Object.assign(Object.assign({}, script), { attributes: Object.assign(Object.assign({}, script.attributes), options.script) });
                });
                data.assetTags.styles = data.assetTags.styles.map((style) => {
                    return Object.assign(Object.assign({}, style), { attributes: Object.assign(Object.assign({}, style.attributes), options.style) });
                });
                callback(null, data);
            });
        });
    }
}
exports.default = HTMLAttributePlugin;
